//+------------------------------------------------------------------+
//|                                                 Heiken AshiR.mq4 |
//|                      Copyright c 2004, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| For Heiken Ashi we recommend next chart settings ( press F8 or   |
//| select on menu 'Charts'->'Properties...'):                       |
//|  - On 'Color' Tab select 'Black' for 'Line Graph'                |
//|  - On 'Common' Tab disable 'Chart on Foreground' checkbox and    |
//|    select 'Line Chart' radiobutton                               |
//+------------------------------------------------------------------+
#property copyright "Copyright ? 2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of indicator bufferov
#property indicator_buffers 4 
//the color of the indicator
#property indicator_color1 Red  
#property indicator_color2 LimeGreen 
#property indicator_color3 Red
#property indicator_color4 LimeGreen
//the thickness of the indicator lines
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 3 
#property indicator_width4 3
//indicator buffery
double L_Buffer[];
double H_Buffer[];
double O_Buffer[];
double C_Buffer[];
//variables with the floating point
double haOpen, haHigh, haLow, haClose;
//+------------------------------------------------------------------+
//| Heiken AshiR initialization function                             |
//+------------------------------------------------------------------+
int init()
  {
//the style of the image of the indicator
   SetIndexStyle(0,DRAW_HISTOGRAM,0);
   SetIndexStyle(1,DRAW_HISTOGRAM,0);
   SetIndexStyle(2,DRAW_HISTOGRAM,0);
   SetIndexStyle(3,DRAW_HISTOGRAM,0);
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
   SetIndexDrawBegin(0,10);
   SetIndexDrawBegin(1,10);
   SetIndexDrawBegin(2,10);
   SetIndexDrawBegin(3,10);
//4 indicator buffera are used for the calculation
   SetIndexBuffer(0,L_Buffer);
   SetIndexBuffer(1,H_Buffer);
   SetIndexBuffer(2,O_Buffer);
   SetIndexBuffer(3,C_Buffer);
//the completion of the initialization
   return(0);
  }
//+------------------------------------------------------------------+
//| Heiken AshiiR teration function                                  |
//+------------------------------------------------------------------+
int start()
  {
if (Bars<=10) return(0);
//the introduction of entire variables and obtaining the alreadycalculated bars
int bar,counted_bars=IndicatorCounted(); 
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
//(bez of this conversion for counted_.bars function JJMASeries willwork incorrectly!!!)
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
bar=Bars-counted_bars-1;
if (bar>Bars-2)bar=Bars-2;
//----
while(bar>=0)
     {
      haOpen=(O_Buffer[bar+1]+C_Buffer[bar+1])/2;
      haClose=(Open[bar]+High[bar]+Low[bar]+Close[bar])/4;
      haHigh=MathMax(High[bar], MathMax(haOpen, haClose));
      haLow=MathMin(Low[bar], MathMin(haOpen, haClose));
      if (haOpen<haClose) 
        {
         L_Buffer[bar]=haLow;
         H_Buffer[bar]=haHigh;
        } 
      else
        {
         L_Buffer[bar]=haHigh;
         H_Buffer[bar]=haLow;
        } 
      O_Buffer[bar]=haOpen;
      C_Buffer[bar]=haClose;
 	   bar--;
     }
//----
   return(0);
  }
//+-------------------------------------------------------------------------+

